
#include <stdio.h>
#include <gtk/gtk.h>

static gint button_press (GtkWidget *, GdkEvent *);
static void menuitem_response (gchar *);

//create  pixmap_widget box from image
GtkWidget *create_img_box(gchar *img_filename,gchar *label_text)
{
	GtkWidget *box;
	GtkWidget *label;
	GtkWidget *image;
	
	box = gtk_hbox_new (FALSE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (box), 2);
	
	image = gtk_image_new_from_file (img_filename);
	label = gtk_label_new (label_text);
	
	/* ͼͱǩװ */
	gtk_box_pack_start (GTK_BOX (box), image, FALSE, FALSE, 3);
	gtk_box_pack_start (GTK_BOX (box), label, FALSE, FALSE, 3);
	gtk_widget_show (image);
	gtk_widget_show (label);
	
	return box;
}


//create  pixmap_widget button from image
GtkWidget *create_img_menuitem(gchar *img_filename,gchar *label_text,gchar *tip_text,GtkSignalFunc callback,gpointer data)
{
	GtkTooltips *tooltip;
	GtkWidget *menuitem,*box;

	/* һµİť */
	menuitem = gtk_menu_item_new ();
	/* Ӱť "clicked" źŵǵĻص */
	g_signal_connect (G_OBJECT (menuitem), "activate",
		G_CALLBACK (callback), (gpointer) data);
	/* ǵĴеĺ */
	box = create_img_box(img_filename, label_text);
	/* tooltip */
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip (tooltip,menuitem,tip_text,NULL);

	/* װʾеĹ */
	gtk_widget_show (box);
	gtk_container_add (GTK_CONTAINER (menuitem), box);

	return (menuitem);
}
int main( int   argc,
          char *argv[] )
{

    GtkWidget *window;
    GtkWidget *menu;
    GtkWidget *menu_bar;
    GtkWidget *root_menu;
    GtkWidget *menu_items;
    GtkWidget *vbox;
    GtkWidget *button;
    char buf[128];
    int i;

    gtk_init (&argc, &argv);

    /* һ´ */
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_widget_set_size_request (GTK_WIDGET (window), 200, 100);
    gtk_window_set_title (GTK_WINDOW (window), "GTK Menu Test");
    g_signal_connect (G_OBJECT (window), "delete_event",
                      G_CALLBACK (gtk_main_quit), NULL);

    /* ʼ˵סԶҲҪ
     * gtk_show_widget() ʾ˵ 
     * ǰ˵Ĳ˵ڳ"Root Menu"ϵʱ
     * ᵯ */
    menu = gtk_menu_new ();

    /* һСѭΪ"test-menu"˵Ŀ
     * עgtk_menu_appendĵáǽһеĲ˵
     * ӵǵĲ˵ϡͨҲÿ˵"clicked"
     * źŲΪһصʡԽʡռ䡣 */
#if 0
    for (i = 0; i < 3; i++)
        {
            /* ƸƵbuf. */
            sprintf (buf, "Test-undermenu - %d", i);

            /* һµĲ˵Ϊ... */
            menu_items = gtk_menu_item_new_with_label (buf);

            /* ...ӵ˵ */
            gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_items);

	    /* ˵ѡʱȤ */
	    g_signal_connect_swapped (G_OBJECT (menu_items), "activate",
		                      G_CALLBACK (menuitem_response), 
                                      g_strdup (buf));

            /* ʾ */
            gtk_widget_show (menu_items);
        }
#endif
    
	menu_items = create_img_menuitem("menu.png","menuitem1","menuitem",
			menuitem_response,
			menu_items);
	gtk_menu_shell_append (GTK_MENU_SHELL (menu), menu_items);
        gtk_widget_show (menu_items);
    /* Ǹ˵Ϊʾڲ˵ϵıǩ
     * ﲻḽһźŴΪֻ
     * ʱĲ˵ */
    root_menu = gtk_menu_item_new_with_label ("Root Menu");

    gtk_widget_show (root_menu);

    /* ָҪ´"menu"
     * Ϊ"root menu"Ĳ˵ */
    gtk_menu_item_set_submenu (GTK_MENU_ITEM (root_menu), menu);

    /* һ˵һťŵ */
    vbox = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (window), vbox);
    gtk_widget_show (vbox);

    /* һ˵԰˵ӵ */
    menu_bar = gtk_menu_bar_new ();
    gtk_box_pack_start (GTK_BOX (vbox), menu_bar, FALSE, FALSE, 2);
    gtk_widget_show (menu_bar);

    /* һťһ˵ */
    button = gtk_button_new_with_label ("press me");
    g_signal_connect_swapped (G_OBJECT (button), "event",
	                      G_CALLBACK (button_press), 
                              menu);
    gtk_box_pack_end (GTK_BOX (vbox), button, TRUE, TRUE, 2);
    gtk_widget_show (button);

    /* Ѳ˵ӵ˵ -- 
     * ˶εġ˵ =) */
    gtk_menu_shell_append (GTK_MENU_SHELL (menu_bar), root_menu);

    /* һʾڣһسĻϡ */
    gtk_widget_show (window);

    gtk_main ();

    return 0;
}

/* 갴ӦwidgetݽĲ˵
 *
 * ע"widget"ǱݽĲ˵
 * µİť
 */

static gint button_press( GtkWidget *widget,
                          GdkEvent *event )
{

    if (event->type == GDK_BUTTON_PRESS) {
        GdkEventButton *bevent = (GdkEventButton *) event; 
        gtk_menu_popup (GTK_MENU (widget), NULL, NULL, NULL, NULL,
                        bevent->button, bevent->time);
        /* ߵôѾ¼¼(buck)
         * ֹͣ */
        return TRUE;
    }

    /* ߵôûд¼ */
    return FALSE;
}


/* ˵ѡʱӡһַ */

static void menuitem_response( gchar *string )
{
    printf ("%s\n", string);
}
