/* misc.c    function for misc
 * Copyright (c) 2004 by SmartLu <smartlu@eyou.com> All Rights Reserved
 * Distributed under the terms of the GNU General Public License (GPL)
 * See the GNU Library General Public License for more details.
 */

#include "srecite.h"

//special phonetic chacaters
gunichar p_array[] = {596,593,601,652,629,240,643,658,331,230,603};

int isPhonetic(gunichar c)
{
	int i;
	for(i=0;i<11;i++)
	{
		if(c==p_array[i])
			return 1;
	}
	return 0;
}

static GtkWidget *dialog;

gchar * unichar_to_utf8(gunichar *uni,gint len)
{
	GString *string;
	gchar *utf8;
	gint i;
	string = g_string_sized_new(len * 4 + 1);
	for( i = 0 ; i < len-5 ; i ++)
	{
	//	if(isPhonetic(uni[i]) )
	//		string = g_string_append_unichar(string,uni[i]);
	//	else
	//		string = g_string_append_c(string,uni[i]);
		

		// '#' is special char defined by me,to show TK_word is end
		if(uni[i] == '#')
			break;
		else
			string = g_string_append_unichar(string,uni[i]);
	}
	utf8 = string -> str;
	g_string_free(string,FALSE);
	return(utf8);
}


/* for wrd format file,convert to fit on kingsoft font */
void phonetic_convert(gchar word[])
{
	gunichar unitmp[256];
	gchar * tmp;
	//strcpy(tmp,word);
	
	int i;
	
	for(i=0;i<strlen(word);i++)
	{

		switch(word[i])
		{
		case '0': unitmp[i]=p_array[0]; break;
		case '1': unitmp[i]=p_array[1]; break;
		case '2': unitmp[i]=p_array[2]; break;
		case '3': unitmp[i]=p_array[3]; break;
		case '4': unitmp[i]=p_array[4]; break;
		case '5': unitmp[i]=p_array[5]; break;
		case '6': unitmp[i]=p_array[6]; break;
		case '7': unitmp[i]=p_array[7]; break;
		case '8': unitmp[i]=p_array[8]; break;
		case '9': unitmp[i]=p_array[9]; break;
		case '/': unitmp[i]=p_array[10]; break;

		default : unitmp[i]=word[i];break;
		}
		
	}

	tmp = unichar_to_utf8(unitmp,G_N_ELEMENTS(unitmp));
	strcpy(word,tmp);

}

//create  pixmap_widget box from image
GtkWidget *create_img_box(gchar *img_filename,gchar *label_text)
{
	GtkWidget *box;
	GtkWidget *label;
	GtkWidget *image;
	
	box = gtk_hbox_new (FALSE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (box), 2);
	
	image = gtk_image_new_from_file (img_filename);
	label = gtk_label_new (label_text);
	
	/* ͼͱǩװ */
	gtk_box_pack_start (GTK_BOX (box), image, FALSE, FALSE, 3);
	gtk_box_pack_start (GTK_BOX (box), label, FALSE, FALSE, 3);
	gtk_widget_show (image);
	gtk_widget_show (label);
	
	return box;
}


//create  pixmap_widget button from image
GtkWidget *create_img_button(gchar *img_filename,gchar *label_text,gchar *tip_text,GtkSignalFunc callback,gpointer data)
{
	GtkTooltips *tooltip;
	GtkWidget *button,*box;

	/* һµİť */
	button = gtk_button_new ();
	/* Ӱť "clicked" źŵǵĻص */
	g_signal_connect (G_OBJECT (button), "clicked",
		G_CALLBACK (callback), (gpointer) data);
	/* ǵĴеĺ */
	box = create_img_box(img_filename, label_text);
	/* tooltip */
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip (tooltip,button,tip_text,NULL);

	/* װʾеĹ */
	gtk_widget_show (box);
	gtk_container_add (GTK_CONTAINER (button), box);

	return (button);
}

//close my dialog
void close_about_dialog()
{
	gtk_grab_remove(dialog);
	gtk_widget_destroy(dialog);
}

//create my dialog
void create_about_dialog(gchar *title,gchar *message,gchar *button_text,gchar *button_xpm)
{
	GtkWidget *message_label;
	GtkWidget *hbox,*vbox,*h_line;
	GtkWidget *xpm_label;
	GtkWidget *button;
	
/* dialog window */
	dialog = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW(dialog),title);
	gtk_window_set_policy(GTK_WINDOW(dialog),FALSE,FALSE,FALSE);
	
/* boxs */
	vbox = gtk_vbox_new(FALSE,0);
	gtk_container_add (GTK_CONTAINER(dialog),vbox);
	gtk_widget_show(vbox);
	hbox = gtk_hbox_new(FALSE,0);
	gtk_box_pack_start (GTK_BOX(vbox),hbox,FALSE,FALSE,0);
	gtk_widget_show(hbox);

/* title xpm */
	xpm_label = create_img_box(PRE_DIR"icon/about.png",title);
	gtk_box_pack_start (GTK_BOX(vbox),xpm_label,FALSE,FALSE,0);
	gtk_widget_show(xpm_label);
	
/* message */
	message_label=gtk_label_new(message);
	gtk_box_pack_start(GTK_BOX(vbox),message_label,FALSE,FALSE,0);
	gtk_widget_show(message_label);

/* h_line */
	h_line = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(vbox),h_line,FALSE,FALSE,0);
	gtk_widget_show(h_line);
	
/* button */
	hbox = gtk_hbox_new(TRUE,0);
	gtk_box_pack_start (GTK_BOX(vbox),hbox,FALSE,FALSE,0);
	gtk_widget_show (hbox);
	
	button = create_img_button(button_xpm,
				button_text,
				"clos my dialog",
				close_about_dialog,
				dialog);

	gtk_box_pack_start(GTK_BOX(hbox),button,FALSE,FALSE,0);
	gtk_widget_show(button);
	
/* other */
	gtk_widget_show(dialog);
	gtk_grab_add(dialog);
}


/* fix window size */
void fix_window_usize()
{
	if(S_conf.style == 1 && S_state.style_step == 1)
	{
		gtk_widget_set_usize(window,WIN_WIDE,0);
		return;
	}
	else
		gtk_widget_set_usize(window,0,0);
}


//create  pixmap_widget menu item from image
GtkWidget *create_img_menu_item(gchar *img_filename,gchar *label_text,gchar *tip_text,GtkSignalFunc callback,gpointer data)
{
	GtkTooltips *tooltip;
	GtkWidget *menu_item,*box;

	menu_item = gtk_menu_item_new ();
	g_signal_connect (G_OBJECT (menu_item), "activate",
		G_CALLBACK (callback), (gpointer) data);
	
	box = create_img_box(img_filename, label_text);
	/* tooltip */
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip (tooltip,menu_item,tip_text,NULL);

	gtk_widget_show (box);
	gtk_container_add (GTK_CONTAINER (menu_item), box);

	//font
	gtk_widget_modify_font((GtkWidget *) menu_item, font);

        gtk_widget_show (menu_item);
	return (menu_item);
}

//create  pixmap_widge tcheck menu item from image
GtkWidget *create_img_check_menu_item(gchar *img_filename,gchar *label_text,gchar *tip_text,GtkSignalFunc callback,gpointer data)
{
	GtkTooltips *tooltip;
	GtkWidget *menu_item,*box;

	menu_item = gtk_check_menu_item_new ();
	g_signal_connect (G_OBJECT (menu_item), "toggled",
		G_CALLBACK (callback), NULL);
	
	box = create_img_box(img_filename, label_text);
	/* tooltip */
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip (tooltip,menu_item,tip_text,NULL);

	gtk_widget_show (box);
	gtk_container_add (GTK_CONTAINER (menu_item), box);

	//font
	gtk_widget_modify_font((GtkWidget *) menu_item, font);
	
        gtk_widget_show (menu_item);
	return (menu_item);
}
// empty
void empty_func()
{}
