/* sentencewin.c    get sentence window
 * Copyright (c) 2004 by SmartLu <smartlu@eyou.com> All Rights Reserved
 * Distributed under the terms of the GNU General Public License (GPL)
 * See the GNU Library General Public License for more details.
 */

#include "srecite.h"

static void sentence_read();//sentence read aloudly

static GtkWidget *sentence_win,*input_entry;
//static GtkWidget *notice_label*ps1_label;
//static GtkWidget *pad_label;
static GtkWidget *quit_button,*sentence_button;


void sentence_quit()
{
        gtk_grab_remove(sentence_win);
        gtk_widget_destroy(sentence_win);	
	show_play();

	//gtk_widget_show(window);

}

/* window of sentence */
void sentence_window()
{
	GtkWidget *vbox,*hbox,*h_line;
	GtkWidget *xpm_label;

/* sentence window */
	sentence_win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(sentence_win),"Read sentence aload with TTS");
	gtk_widget_set_usize(sentence_win,600,150);
	gtk_widget_set_uposition(sentence_win,300,200);
	gtk_container_border_width(GTK_CONTAINER(sentence_win),0);
	gtk_signal_connect (GTK_OBJECT (sentence_win), "delete_event",
			GTK_SIGNAL_FUNC(sentence_quit), sentence_win);

/* vbox */
	vbox = gtk_vbox_new(TRUE,0);
	gtk_container_add(GTK_CONTAINER(sentence_win),vbox);
	gtk_widget_show(vbox);
/* hbox */
	hbox = gtk_hbox_new(TRUE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
	gtk_widget_show(hbox);
	

/* sentence label */	
	xpm_label = create_img_box(PRE_DIR"icon/about.png",
			"Read Aloud sentence you inputted with festival TTS");
	gtk_box_pack_start(GTK_BOX(hbox),xpm_label,FALSE,FALSE,0);
	gtk_widget_show(xpm_label);
	
/* input word editor */ 
	input_entry = gtk_entry_new();
	gtk_entry_set_max_length (GTK_ENTRY(input_entry), 240);
	g_signal_connect (G_OBJECT(input_entry), "activate",
		G_CALLBACK (sentence_read),input_entry);

	gtk_box_pack_start(GTK_BOX(vbox),input_entry,FALSE,FALSE,0);
	gtk_widget_show(input_entry);

	// font
	gtk_widget_modify_font((GtkWidget *) input_entry, font);


/* h_line */
	h_line = gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(vbox),h_line,FALSE,FALSE,0);
	gtk_widget_show(h_line);
	

/* button */
	hbox = gtk_hbox_new(TRUE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
	gtk_widget_show(hbox);

	/* sentence button */	
	sentence_button = create_img_button(PRE_DIR"icon/read.png",
				"Read aloud",
				"Read aloud",
				sentence_read,
				sentence_button);
	
	gtk_box_pack_start(GTK_BOX(hbox),sentence_button,FALSE,FALSE,0);
	gtk_widget_show(sentence_button);

	/* quit button */
	quit_button = create_img_button(PRE_DIR"icon/exit.png",
				"Quit",
				"Quit",
				sentence_quit,
				quit_button);
	
	gtk_box_pack_start(GTK_BOX(hbox),quit_button,FALSE,FALSE,0);
	gtk_widget_show(quit_button);


/* show all!over! */

	gtk_widget_set_sensitive(input_entry,1);
	show_stop();
	//gtk_widget_hide(window);

	gtk_widget_show(sentence_win);

}


//sentence read aloudly
static void sentence_read()
{
	g_print("sentence read!!\n");
	gchar word[256];
	
	strcpy(word,gtk_entry_get_text(GTK_ENTRY(input_entry)));

	tts_read(word);

	//select input entry
	gtk_editable_select_region(GTK_EDITABLE (input_entry),
			0,GTK_ENTRY(input_entry)->text_length);
}
