/* srecite.h    head file of whole project
 * Copyright (c) 2004 by SmartLu <smartlu@eyou.com> All Rights Reserved
 * Distributed under the terms of the GNU General Public License (GPL)
 * See the GNU Library General Public License for more details.
 */


#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <time.h>
#include <ctype.h>
#define LOGO "SRecite 0.6.2 by SmartLu"

#define WIN_WIDE 280
#define WIN_HEIGHT 50

#define MAX_WORD 10000


#ifndef CONFIG
#define PRE_DIR ""
#endif

#ifndef CONFIG
#define HOME_DIR ""
#endif

/*
#define PRE_DIR "/usr/local/share/srecite/"
#else
*/

// mainwindow.c
extern GtkWidget *label,*window;//window and label
extern GtkWidget *menu;//popupmenu 

// toolbar.c
extern GtkWidget *toolbar;//

extern GtkWidget* stop_button;
extern GtkWidget* back_button;
extern GtkWidget* play_button;
extern GtkWidget* next_button;

// popmenu.c
extern GtkWidget * pron_menu_item;
extern GtkWidget * random_menu_item;
extern GtkWidget * style_menu_item;
extern GtkWidget * line_menu_item;

// wordfile.c
//word book for word file,limition 10000 
extern gchar wordbook[MAX_WORD][256];
//tag ignore word,1 = ignore,0 = show regularly
extern gchar  word_tag[MAX_WORD];

extern int word_count;//count of word

// mainwindow.c
extern PangoFontDescription *font;//font
extern gchar font_desc[255];
extern PangoFontDescription *font2;//font
extern gchar font2_desc[255];

//home path
extern gchar home_path[1024];

struct conf_st
{
	gchar filename[255];	//word file name
	//new add

	gint style;		//0=normal,1=EN first
	gint random;		//0=no random,1=random
	
	gint time_interval;	//time interval of show
	gint  EN_word;
	gint  TK_word;
	gint  CH_word;

	gint  win_x;
	gint  win_y;

	gint test_counter;	// test game counter

	gchar font[255];	//font
	gchar fontsize[255];	//font size

	gint pronounce;		//0=off,1=on
	gint show_format;	//0=3line,1=2line,2=1line
	
	//no use
	gchar back_color;
	gchar text_color;
		
	gint auto_save;

}; 

struct state_st
{
	int word_index;//word index of wordbook[index][]

	gint toolbar_show;//toolbar show or not
	gint timer;	//timer_1

	int style_step;//flag of which style2 step,0 or 1
	
	FILE * wordfile;//wordfile FILE
	
	//no use
	gint  win_h;
	gint  win_w;

};
	  
struct line_st
{
	gchar EN_word[256];//English
	gchar TK_word[256]; //spoken voice
	gchar CH_word[256];//Chinese
};

extern struct conf_st S_conf;
extern struct state_st S_state;
extern struct line_st S_line;

/* mainwindow.c */
void init_conf();
void init_state();
void init_all();//init

void main_window(); //show main_window
void quit_window(); //quit all
void timer_install();/* insall timer 1 and 2 */
void timer_uninstall();/* uninsall timer 1 and 2 */
void about();/* show about */


/* wordfile.c */
gint open_wordfile();//open wordfile with S_conf.filename
void read_line(); //get S_line from wordfile
void init_wordbook();//read wordfile to wordbook[][],40000 words limition 
void init_word_tag();/* init word_tag[] */
void ignore_word();/* ignore word */

/* popupmenu.c */
void init_menu();
	/* show popupmenu when right click */
int popupmenu_show(GtkWidget *widget, GdkEvent *event);
void check_toggle_menu_items();/* check config  menu item  */


/* conffile.c */
void load_conf();/* load srecite.conf */
void change_style();/* change show word style,0=normal,1=EN first */
void save_conf();/* save srecite.conf */
void pronounce_switch();/* change show pronuciation switch,0=off,1=on */
void show_format_switch();/* change show format switch,0=3line,1=1line */


/* statefile.c */
void save_state(gchar * savefile);/* save_state to saveN file,now only 1.sav */
void load_state(gchar * savefile);/* load_state to saveN file,now only 1.sav */
void restart_for_load();/* restart file for load *.sav */
	/* for popmenu */
void save_state_0();
void save_state_1();
void save_state_2();
void save_state_3();

void load_state_0();
void load_state_1();
void load_state_2();
void load_state_3();


/* showword.c */
	/* stop show word when menuitem stop is click*/
void show_stop();
	/* play show word when menuitem play is click*/
void show_play();
	/* back show word when menuitem back is click*/
void show_back();
	/* next show word when menuitem next is click*/
void show_next();
	/* random show word when menuitem random is click*/
void show_random();

gint show_word(); //show S_line in label,first step
void show_banner(gchar * banner);/* show banner */


/* toolbar.c */
	/* show toolbar when click right button */
void toolbar_show();
	/* create toolbar as return value */
void create_toolbar(GtkWidget *window);


/* filewindow.c */
void file_selection();/* file selection window */
void restart_for_file_sel();/* restart file after file selection */


/* misc.c */
	/* for wrd format file,convert to fit on kingsoft font */
void phonetic_convert(gchar word[]);
	//create  pixmap_widget box from image
GtkWidget *create_img_box(gchar *img_filename,gchar *label_text);
	//create  pixmap_widget button from image
GtkWidget *create_img_button(gchar *img_filename,gchar *label_text,
		gchar *tip_text,GtkSignalFunc callback,gpointer data);
	//create my dialog
void create_about_dialog(gchar *title,gchar *message,gchar *button_text,gchar *button_xpm);
void fix_window_usize();/* fix window size */
	//create  pixmap_widget menu item from image
GtkWidget *create_img_menu_item(gchar *img_filename,gchar *label_text,gchar *tip_text,GtkSignalFunc callback,gpointer data);
	//create  pixmap_widget_check menu item from image
GtkWidget *create_img_check_menu_item(gchar *img_filename,gchar *label_text,gchar *tip_text,GtkSignalFunc callback,gpointer data);

void empty_func();// empty


/* testgame.c */
void testgame_window();/* window of test game */


/* minidict.c */
void minidict_window();/* window of minidict */
int do_EN_search(gchar word[256],int begin,int end);//search for EN


/* draftpaper.c */
void draftpaper_window();/* window of draftpaer */


/* readword.c  */
void read_word(gchar * word);// read aloudly with TTS
void tts_read(gchar * tts_str);// festival tts read


/* sentencewin.c */
void sentence_window();/* window of minidict */

/* gtkamber.c */
void transparent_init ();/* init transparent WINDOW and MENU */

/* sentencewin.c */
void goto_window();/* window of sentence */

