/* statefile.c    function for statefile
 * load_state and save_state
 * Copyright (c) 2004 by SmartLu <smartlu@eyou.com> All Rights Reserved
 * Distributed under the terms of the GNU General Public License (GPL)
 * See the GNU Library General Public License for more details.
 */

#include "srecite.h"
#include <sys/stat.h>
#include <sys/types.h>

/* save_state to saveN file,now only 1.sav */
void save_state(gchar * savefile)
{
	
	FILE *fp=NULL;
	int i;	
	
	gchar strPath[1024];
	gchar home_savefile[1024];

	strcpy(home_savefile,home_path);
	strcat(home_savefile,savefile);

	strcpy(strPath, home_path);
		    
	
	// remove timer
	show_stop();
	
	show_banner("Saving ...");

	// check home path dir
	if (access (strPath, 0))
	{
		mkdir (strPath, S_IRWXU);
        	g_print("mkdir (%s) !!\n",strPath);
	}
	
	// check ~/.srecite/sav/
	strcat (strPath, "sav/");
	if (access (strPath, 0))
	{
		mkdir (strPath, S_IRWXU);
        	g_print("mkdir (%s) !!\n",strPath);
	}


	
	if ((fp=fopen(home_savefile,"w")) == NULL)
	{
		g_print("Can't open *.sav (%s)!!\n",home_savefile);
		g_print("Please check ~/.srecite/sav !\n");

		exit(0);
	}
	// save S_conf	
	fprintf(fp,"%s\n",S_conf.filename);
	//fprintf(fp,"%d\n",S_conf.filename);


	// save S_state
	fprintf(fp,"%d\n",S_state.word_index);

	// save word_tag[]
	for(i=0;i<MAX_WORD;i++)
	{
		if(word_tag[i] == 1)
			fprintf(fp,"%d:", i);
	}

        g_print("------ save %s completed ------\n",home_savefile);
	
	fclose(fp);

	show_play();
	// add timer
}

/* load_state to saveN file,now only 1.sav */
void load_state(gchar * savefile)
{
	FILE *fp=NULL;

	gchar home_savefile[1024];

	strcpy(home_savefile,home_path);
	strcat(home_savefile,savefile);

	if ((fp=fopen(home_savefile,"r")) == NULL)
	{	
		g_print("Can't open *.sav (%s)!!\n",home_savefile);
		g_print("Please check ~/.srecite/sav/ !\n");

		strcpy(S_conf.filename,PRE_DIR"wordbooks/tf.wrd");

		if(strcmp(savefile,"sav/0.sav"))
			show_banner("Loading ...");
	
		restart_for_load();

		S_state.word_index = 0;
		
	        g_print("------ load default completed ------ \n");
	//	exit(0);
	}
	else
	{
		// load S_conf	
		fscanf(fp,"%s\n",S_conf.filename);

		if(strcmp(savefile,"sav/0.sav"))
			show_banner("Loading ...");
	
		restart_for_load();
		// load S_state
		fscanf(fp,"%d\n",&S_state.word_index );
	
		// save word_tag[]
		while( !feof(fp) )
		{
			int n;
			fscanf(fp,"%d:",&n);
			word_tag[n] = 1;
		}

	
	        g_print("------ load %s completed ------ \n",home_savefile);
		fclose(fp);
	}
	
}

/* restart file for load *.sav */
void restart_for_load()
{
	// remove timer
	show_stop();

	init_wordbook();

	//fseek(S_state.wordfile,S_state.pos,SEEK_SET);
	
	show_play();
	//add timer
}

// 0 is auto save and load
void save_state_0()	{save_state("sav/0.sav");}
void save_state_1()	{save_state("sav/1.sav");}
void save_state_2()	{save_state("sav/2.sav");}
void save_state_3()	{save_state("sav/3.sav");}


void load_state_0()	{load_state("sav/0.sav");}
void load_state_1()	{load_state("sav/1.sav");}
void load_state_2()	{load_state("sav/2.sav");}
void load_state_3()	{load_state("sav/3.sav");}

